/*
 * Created on 16.01.2007
 */
package ssadchaz;

import java.util.*;
import java.util.regex.*;

public class Abenteuer {
	
	String name;
	IO io;
	Abschnitt[] abschnitte;
	int gesamtpunkte;
	static String[][] werte = {{"vorname", "nachname", "gAP", "D", "S", "H",
				"MU", "KL", "IN", "CH", "FF", "GE", "KO", "KK",
				"LE", "AU", "MR", "RS", "BE", "AT", "PA",
				"wuerfelTP", "zusatzTP"},
				{"Vorname", "Nachname", "Abenteuerpunkte", "Dukaten", "Silbertaler", "Heller",
                "Mut", "Klugheit", "Intuition", "Charisma", "Fingerfertigkeit", "Gewandheit", "Konstitution", "Krperkraft",
                "Lebensenergie", "Ausdauer", "Magieresistenz", "Rstungsschutz", "Behinderung", "Attacke", "Parade",
                "Anzahl der Wrfel", "Zusatz-TP"}};
	static String[] folgewerte = {"Stufe", "maxLE", "maxAU", "Basiswert PA", "Ausweichen"};							
	static String[][] talente;
	static String[] variablen;
	
	public Abenteuer(){
		this.gesamtpunkte = 0;
	}
	
	static int wandleZahl(String zahl){
		try{
			zahl = zahl.trim();
			return Integer.parseInt(zahl);
		}catch(Exception e){
			return -1;
		}
	}
	
	static String wandleString(String s){
		s = s.replaceAll("", "ae");
		s = s.replaceAll("", "oe");
		s = s.replaceAll("", "ue");
		s = s.replaceAll("", "ss");
		s = s.replaceAll(" ", "");
		return s;
	}

	static String wandleTop(String s, String[] liste){
		s = " " + s + " ";
		for(int i = 0; i < liste.length; i++){
			Pattern pattern = Pattern.compile("\\W"+liste[i]+"\\W");
	        Matcher matcher = pattern.matcher(s);
	        String t = "";
			int k = 0;
		    while(matcher.find(k)){
		    	t = t + s.substring(k, matcher.start()+1) + "top." + liste[i];
		    	k = matcher.end()-1;
		    }
		    t = t + s.substring(k);
		    s = t;
		}
		return s.trim();		
	}
	
	static String wandleTop(int i){
		return wandleTop(""+i);
	}
	
	static String wandleTop(String s){
		s = wandleTop(s, werte[0]);
		s = wandleTop(s, folgewerte);
		s = wandleTop(s, talente[0]);
		s = wandleTop(s, variablen);
		return s;
	}
	
	static String fuelleDreistellig(String zahl){
		if(zahl.length() < 2){
			zahl = "00"+zahl;
		}else if(zahl.length() < 3){
			zahl = "0"+zahl;
		}
		return zahl;
	}

	static String fuelleDreistellig(int n){
		String zahl = n + "";
		if(zahl.length() < 2){
			zahl = "00"+zahl;
		}else if(zahl.length() < 3){
			zahl = "0"+zahl;
		}
		return zahl;
	}

	String setzeStart(String zeile){
		String start = "";
		zeile = zeile.trim().substring(2, zeile.length()-2);
		String [] param = zeile.split(";");
		if(param[0].equals("PROBE") || param[0].startsWith("TEXT") || param[0].startsWith("LINK") || param[0].equals("KAMPF") || param[0].equals("REGENERATION") || param[0].equals("GELD") || param[0].startsWith("WERT") || param[0].startsWith("AP") || param[0].startsWith("SE")){
			start = "   " + param[0] + "();" + System.getProperty("line.separator");
		}				
		return start;
	}
	
	boolean setzeSkript(String zeile, Abschnitt a){
		boolean skript = true;
		zeile = zeile.trim();
		zeile = zeile.substring(2, zeile.length()-2);
		String [] param = zeile.split(";");
		if(param[0].equals("PROBE")){
		//Unterscheidung zwischen Eigenschaftsprobe (5-6 Parameter) und Talentprobe (8-11 Parameter)	
			switch(param.length){
				case  5:;
				case  6: skript = setzeEigenschaftsprobeskript(param, a); break;
				case  8:;
				case  9:;
				case 10:;
				case 11: skript = setzeTalentprobeskript(param, a); break;
			}
		}else if(param[0].startsWith("TEXT")){
			skript = setzeTextskript(param, a);
		}else if(param[0].startsWith("LINK")){
			skript = setzeLinkskript(param, a);
		}else if(param[0].equals("KAMPF")){
			skript = setzeKampfskript(param, a);
		}else if(param[0].equals("REGENERATION")){
			skript = setzeRegenerationskript(param, a);
		}else if(param[0].equals("GELD")){
			skript = setzeGeldskript(param, a);
		}else if(param[0].startsWith("WERT")){
			skript = setzeWertskript(param, a);
		}else if(param[0].startsWith("AP")){
			skript = setzeAPskript(param, a);
		}else if(param[0].startsWith("SE")){
			skript = setzeSEskript(param, a);
		}
		return skript;
	}
	
	String setzeBaustein(String zeile){
		String baustein = "";
		zeile = zeile.trim().substring(2, zeile.length()-2);
		String [] param = zeile.split(";");
		if(param[0].equals("PROBE")){
			switch(param.length){
				case  5:;
				case  6: baustein = setzeProbewuerfel(param[3].trim(), param[4].trim(), true); break;
				case  8:;
				case  9: baustein = setzeProbewuerfel(); break;
				case 10:;
				case 11: baustein = setzeProbewuerfel(param[8].trim(), param[9].trim()) + System.getProperty("line.separator"); break;
			}
		}else if(param[0].startsWith("LINK")){
			baustein = setzeLinks(param[0].trim());
		}else if(param[0].equals("KAMPF")){
			baustein = setzeKampftabelle();
		}
		return baustein;
	}
	
	String ersetzeMarkierung(String zeile){
		for(int i = zeile.indexOf("{"); i != -1; i = zeile.indexOf("{", i+1)){
			int j = zeile.indexOf("}", i);
			String mark = zeile.substring(i+1, j);
			String end = "</span>";
			StringBuffer ersatz = new StringBuffer(zeile);
			if(mark.endsWith("/")){
				end = "";
				mark = mark.substring(0, mark.length()-1);
			}
			if(mark.startsWith("/"))
				ersatz.replace(i, j+1, "</span>");
			else
				ersatz.replace(i, j+1, "<span id=\""+mark+"\">"+end);
			zeile = ersatz.toString();
		}
		return zeile;
	}
	
	boolean setzeEigenschaftsprobeskript(String param[], Abschnitt a){
		Eigenschaftsprobe e = new Eigenschaftsprobe(param);
		a.setzeSkript(e);
		a.setzeNachfolger(abschnitte[e.gelungen], "Gelungen", true);
		a.setzeNachfolger(abschnitte[e.misslungen], "Misslungen", true);
		return true;
	}
	
	boolean setzeTalentprobeskript(String param[], Abschnitt a){
		Talentprobe t = new Talentprobe(param);
		a.setzeSkript(t);
		a.setzeNachfolger(abschnitte[t.gelungen], "Gelungen", true);
		a.setzeNachfolger(abschnitte[t.misslungen], "Misslungen", true);
		if(t.verweigern)
			a.setzeNachfolger(abschnitte[t.wedernoch], "Verweigern", true);
		return true;
	}
	
	String setzeProbewuerfel(String abschnitt, String linktext, boolean eigenschaft){
		String text = System.getProperty("line.separator") +
		  	          "<h3><span id=\"m\"></span></h3>" + System.getProperty("line.separator") +
		  	          "<form name=\"F\">" + System.getProperty("line.separator") +
		  	          "<table align=\"center\" width=60%>" + System.getProperty("line.separator") +
		  	          "   <tr>" + System.getProperty("line.separator") +
		  	          "      <td>&nbsp;</td>" + System.getProperty("line.separator") +
		  	          "      <td id=\"w1\" class=\"px14w\" style=\"background-image:url(../Bilder/Rot.png); width:64px; height:69px\"></td>" + System.getProperty("line.separator") +
		  	          "      <td>&nbsp;</td>" + System.getProperty("line.separator") +
		  	          "   </tr>" + System.getProperty("line.separator") +
		  	          "   <tr><td>&nbsp;</td></tr>" + System.getProperty("line.separator") +
		  	          "   <tr>" + System.getProperty("line.separator") +
		  	          "      <td colspan=3><input name=\"button\" type=\"button\" value=\" Wrfeln! \" onfocus=\"blur()\" onclick=\"wuerfel()\"></td>" + System.getProperty("line.separator") +
		  	          "   </tr>" + System.getProperty("line.separator") +
		  	          "</table>" + System.getProperty("line.separator") +
		  	          "</form>" + System.getProperty("line.separator") +
		  	          System.getProperty("line.separator") +
		  	          "<span id=\"links\">" + System.getProperty("line.separator") +
		  	          "</span>" + System.getProperty("line.separator");		
		return text;
	}
	
	String setzeProbewuerfel(){
		return setzeProbewuerfel(null, null);
	}
	
	String setzeProbewuerfel(String abschnitt, String linktext){
		String link = "";
		if(abschnitt != null){
			link = "<a href=\""+fuelleDreistellig(abschnitt)+".html\">"+linktext+" ["+abschnitt+"]</a><br>" + System.getProperty("line.separator");
		}
		String text = System.getProperty("line.separator") +
					  "<br>" + System.getProperty("line.separator") +
					  "<h3><span id=\"m\"></span></h3>" + System.getProperty("line.separator") +
					  "<form name=\"F\">" + System.getProperty("line.separator") +
					  "<table align=\"center\" width=60%>" + System.getProperty("line.separator") +
					  "   <tr>" + System.getProperty("line.separator") +
					  "      <td id=\"e1\"></td>" + System.getProperty("line.separator") +
					  "      <td></td>" + System.getProperty("line.separator") +
					  "      <td id=\"e2\"></td>" + System.getProperty("line.separator") +
					  "      <td></td>" + System.getProperty("line.separator") +
		              "      <td id=\"e3\"></td>" + System.getProperty("line.separator") +
		              "   </tr>" + System.getProperty("line.separator") +
		              "   <tr>" + System.getProperty("line.separator") +
		              "      <td id=\"w1\" class=\"px14w\" style=\"background-image:url(../Bilder/Rot.png); width:64px; height:69px\"></td>" + System.getProperty("line.separator") +
		              "      <td></td>" + System.getProperty("line.separator") +
		              "      <td id=\"w2\" class=\"px14w\" style=\"background-image:url(../Bilder/Blau.png); width:70px; height:69px\"></td>" + System.getProperty("line.separator") +
		              "      <td></td>" + System.getProperty("line.separator") +
		              "      <td id=\"w3\" class=\"px14w\" style=\"background-image:url(../Bilder/Schwarz.png); width:78px; height:69px\"></td>" + System.getProperty("line.separator") +
		              "   </tr>" + System.getProperty("line.separator") +
		              "   <tr><td>&nbsp;</td></tr>" + System.getProperty("line.separator") +
		              "   <tr>" + System.getProperty("line.separator") +
		              "      <td colspan=5><input name=\"button\" type=\"button\" value=\" Wrfeln! \" onfocus=\"blur()\" onclick=\"wuerfel()\"></td>" + System.getProperty("line.separator") +
		              "   </tr>" + System.getProperty("line.separator") +
		              "</table>" + System.getProperty("line.separator") +
		              "</form>" + System.getProperty("line.separator") +
		              System.getProperty("line.separator") +
		              "<span id=\"links\">" + System.getProperty("line.separator") +
		              link +
		              "</span>" + System.getProperty("line.separator");		
		return text;
	}
	
	boolean setzeTextskript(String[] param, Abschnitt a){
		Text t = new Text(param);
		a.setzeSkript(t);
		
		return true;
	}
	
	boolean setzeLinkskript(String[] param, Abschnitt a){
		Link l = new Link(param);
		a.setzeSkript(l);
		for(int i = 0; i < l.laenge; i++){
			a.setzeNachfolger(abschnitte[wandleZahl(l.links[i][1])], l.links[i][2], true);
		}
		return true;
	}	
	
	boolean setzeKampfskript(String[] param, Abschnitt a){
		Kampf k = new Kampf(param);
		a.setzeSkript(k);
		a.setzeNachfolger(abschnitte[k.sieg], k.textSieg, true);
		a.setzeNachfolger(abschnitte[k.niederlage], k.textNiederlage, true);
		return true;
	}

	boolean setzeRegenerationskript(String[] param, Abschnitt a){
		Regeneration r = new Regeneration(param);
		a.setzeSkript(r);
		return true;
	}
	
	boolean setzeGeldskript(String[] param, Abschnitt a){
		Geld g = new Geld(param);
		a.setzeSkript(g);
		return true;
	}
		
	boolean setzeWertskript(String[] param, Abschnitt a){
		Wert w = new Wert(param);
		a.setzeSkript(w);
		return true;
	}	
	
	boolean setzeAPskript(String[] param, Abschnitt a){
		AP ap = new AP(param);
		a.setzeSkript(ap);
		gesamtpunkte = gesamtpunkte + ap.punkte;
		return true;
	}
	
	boolean setzeSEskript(String[] param, Abschnitt a){
		SE se = new SE(param);
		a.setzeSkript(se);		
		return true;
	}
                      
	String setzeLinks(String name){
		return "<span id=\""+name+"\"></span>" + System.getProperty("line.separator");
	}
	
	String setzeKampftabelle(){
		String text = "<table align=\"center\" style=\"table-layout:fixed\" width=60%>" + System.getProperty("line.separator") +
					  "   <tr>" + System.getProperty("line.separator") +
					  "      <td><b id=\"name\"></b></td>" + System.getProperty("line.separator") +
					  "      <td><b>Gegner</b></td>" + System.getProperty("line.separator") +
					  "   </tr>" + System.getProperty("line.separator") +
					  "</table>" + System.getProperty("line.separator") +
					  System.getProperty("line.separator") +
					  "<table align=\"center\" style=\"table-layout:fixed\" width=60%>" + System.getProperty("line.separator") +
					  "   <tr>" + System.getProperty("line.separator") +
					  "      <td>&nbsp;</td>" + System.getProperty("line.separator") +
					  "      <td id=\"w1\" class=\"px14w\" style=\"background-image:url(../Bilder/Rot.png); width:64px; height:69px\">&nbsp;</td>" + System.getProperty("line.separator") +
					  "      <td>&nbsp;</td>" + System.getProperty("line.separator") +
					  "      <td>&nbsp;</td>" + System.getProperty("line.separator") +
					  "      <td style=\"width:64px;\"><img id=\"gegner\" src=\"../Bilder/Gegner1.gif\" width=64 height=68 border=0></td>" + System.getProperty("line.separator") +
					  "      <td>&nbsp;</td>" + System.getProperty("line.separator") +
					  "   </tr>" + System.getProperty("line.separator") +
					  "</table>" + System.getProperty("line.separator") +
					  System.getProperty("line.separator") +
					  "<table align=\"center\" style=\"table-layout:fixed\" width=60%>" + System.getProperty("line.separator") +
					  "   <tr>" + System.getProperty("line.separator") +
					  "      <td id=\"t1\">&nbsp;</td>" + System.getProperty("line.separator") +
					  "      <td id=\"t2\">&nbsp;</td>" + System.getProperty("line.separator") +
					  "   </tr>" + System.getProperty("line.separator") +
					  "</table>" + System.getProperty("line.separator") +
					  System.getProperty("line.separator") +
					  "<form name=\"F\">" + System.getProperty("line.separator") +
					  "<table align=\"center\" style=\"table-layout:fixed\" width=60%>" + System.getProperty("line.separator") +
					  "   <tr>" + System.getProperty("line.separator") +
					  "      <td><input name=\"button\" type=\"button\" value=\" Kampf! \" onfocus=\"blur()\" onclick=\"wuerfel()\"></td>" + System.getProperty("line.separator") +
					  "      <td>&nbsp;</td>" + System.getProperty("line.separator") +
					  "   </tr>" + System.getProperty("line.separator") +
					  "</table>" + System.getProperty("line.separator") +
					  "</form>" + System.getProperty("line.separator") +
					  System.getProperty("line.separator") +
					  "<form name=\"AT\">" + System.getProperty("line.separator") +
					  "<table align=\"center\" border=0 style=\"table-layout:fixed\" width=60%>" + System.getProperty("line.separator") +
					  "   <tr>" + System.getProperty("line.separator") +
					  "      <td width=50% colspan=2><b>Angriffsoptionen</b></td>" + System.getProperty("line.separator") +
					  "      <td width=50%>&nbsp;</td>" + System.getProperty("line.separator") +
					  "   </tr>" + System.getProperty("line.separator") +
					  "   <tr>" + System.getProperty("line.separator") +
					  "      <td class=\"left\"><input type=\"checkbox\" name=\"cbFinte\" value=\"0\" onfocus=\"blur()\" onclick=\"setzeFinte(0)\"> Finte</td>" + System.getProperty("line.separator") +
					  "      <td class=\"right\">" + System.getProperty("line.separator") +
					  "          <input name=\"bFinteMinus\" type=\"button\" value=\"-\" onfocus=\"blur()\" onclick=\"setzeFinte(-1)\">" + System.getProperty("line.separator") +
					  "          <input name=\"Finte\" value=\"0\" type=\"text\" size=\"2\" maxlength=\"2\">" + System.getProperty("line.separator") +
					  "          <input name=\"bFintePlus\" type=\"button\" value=\"+\" onfocus=\"blur()\" onclick=\"setzeFinte(1)\">" + System.getProperty("line.separator") +
					  "      </td>" + System.getProperty("line.separator") +
					  "      <td>&nbsp;</td>" + System.getProperty("line.separator") +
					  "   </tr>" + System.getProperty("line.separator") +
					  "   <tr>" + System.getProperty("line.separator") +
					  "      <td class=\"left\"><input type=\"checkbox\" name=\"cbWuchtschlag\" value=\"0\" onfocus=\"blur()\" onclick=\"setzeWuchtschlag(0)\"> Wuchtschlag</td>" + System.getProperty("line.separator") +
					  "      <td class=\"right\">" + System.getProperty("line.separator") +
					  "          <input name=\"bWuchtschlagMinus\" type=\"button\" value=\"-\" onfocus=\"blur()\" onclick=\"setzeWuchtschlag(-1)\">" + System.getProperty("line.separator") +
					  "          <input name=\"Wuchtschlag\" value=\"0\" type=\"text\" size=\"2\" maxlength=\"2\">" + System.getProperty("line.separator") +
					  "          <input name=\"bWuchtschlagPlus\" type=\"button\" value=\"+\" onfocus=\"blur()\" onclick=\"setzeWuchtschlag(1)\">" + System.getProperty("line.separator") +
					  "      </td>" + System.getProperty("line.separator") +
					  "      <td>&nbsp;</td>" + System.getProperty("line.separator") +
					  "   </tr>" + System.getProperty("line.separator") +
					  "</table>" + System.getProperty("line.separator") +
					  "</form>" + System.getProperty("line.separator") +
					  System.getProperty("line.separator") +
					  "</p>" + System.getProperty("line.separator") +
					  "<span id=\"links\">" + System.getProperty("line.separator") +
					  "<a href=000.html\"></a>" + System.getProperty("line.separator");
		return text;
	}
	
	boolean setzeTalente(String s){
		int anzahl = 0;
		
		for(int y = 0, x = 0; y != -1; x = y+1){
			y = s.indexOf(";", x+1);
			if(y != -1){
				anzahl++;
			}
		}
		
		talente = new String[2][anzahl];
		
		String talent = "";
		for(int y = 0, x = 0, i = 0; y != -1; x = y+1, i++){
			y = s.indexOf(";", x+1);
			if(y != -1){
				talent = s.substring(x, y).trim();
				if(talent.endsWith("(boolean)")){
					talente[0][i] = talent.substring(0, talent.lastIndexOf("("));
					talente[1][i] = "boolean";
				}else{
					talente[0][i] = talent;
					talente[1][i] = "int";
				}
			}
		}	
		return true;
	}
	
	boolean setzeVariablen(String s){
		int anzahl = 0;
		
		for(int y = 0, x = 0; y != -1; x = y+1){
			y = s.indexOf(";", x+1);
			if(y != -1){
				anzahl++;
			}
		}
		
		variablen = new String[anzahl];
	
		String var = "";
		for(int y = 0, x = 0, i = 0; y != -1; x = y+1, i++){
			y = s.indexOf(";", x+1);
			if(y != -1){
				var = s.substring(x, y).trim();
				variablen[i] = wandleString(var);
			}
		}
		return true;
	}
	
	public String toString(){
		String s = "";
		for(int i = 1; i < abschnitte.length; i++){
			s = s + abschnitte[i].nr;
			
			if(abschnitte[i].gebraucht && !abschnitte[i].da){
				s = s + " wird bentigt von ";
				for(int k = 0; k < abschnitte[i].vorgaenger.length; k++){
					s = s + "[" + abschnitte[i].vorgaenger[k].nr + "]";
				}
				s = s + ".";
			}
			if(!abschnitte[i].gebraucht && !abschnitte[i].da){
				s = s + " ist frei.";
			}
			if(!abschnitte[i].gebraucht && abschnitte[i].da){
				s = s + " ist ohne Vorgnger";
			}
			if(abschnitte[i].nachfolger != null){
				s = s + ": ";
				for(int j = 0; j < abschnitte[i].nachfolger.length; j++){
					s = s + "[" + abschnitte[i].nachfolger[j].nr + "]";
				}
			}
			if(abschnitte[i].skripte != null){
				s = s + " ";
				for(Skript akt = abschnitte[i].skripte; akt != null; akt = akt.f){
					s = s + "(" + akt.toString() + ")";
				}
			}
			s = s + "\n";
		}
		s = s + "Gesamtpunkte: " + gesamtpunkte;
		return s;
	}

	boolean liesDatei(String datei){
		this.io = new IO();
		StringBuffer sb = io.liesDatei(datei);
		String s;
		s = sb.substring(0, sb.indexOf("#"));
		this.name = s.trim();
		sb.delete(0, sb.indexOf("#")+2);
		
		s = sb.substring(0, sb.indexOf("#"));
		setzeTalente(s);		
		sb.delete(0, sb.indexOf("#")+2);
		
		s = sb.substring(0, sb.indexOf("#"));
		setzeVariablen(s);		
		sb.delete(0, sb.indexOf("#")+2);
		
		s = sb.substring(0, sb.indexOf("#"));
		int n = wandleZahl(s.trim());
		if(n != -1){
			abschnitte = new Abschnitt[n+1];
			for(int i = 0; i < abschnitte.length; i++){
				abschnitte[i] = new Abschnitt(i);
			}
		}
		sb.delete(0, sb.indexOf("#")+2);
		
		for(; sb.indexOf("#") != -1;){
			s = sb.substring(0, sb.indexOf("#"));
			int nr = wandleZahl((s.substring(0, s.indexOf(System.getProperty("line.separator")))));
			s = s.substring(s.indexOf(System.getProperty("line.separator"))+2, s.length());
			String start = "";
			String text = "";
			String bausteine = "";
			String links = "";
			for(boolean e = false;!e;){
				String zeile = s.substring(0, s.indexOf(System.getProperty("line.separator")));
				zeile = ersetzeMarkierung(zeile);
				if(zeile.indexOf("[") == -1){
					text = text + zeile + "<br>" + System.getProperty("line.separator");
					s = s.substring(s.indexOf(System.getProperty("line.separator"))+2, s.length());
				}else{
					e = true;
				}
			}
			for(boolean e = false;!e;){
				if(!s.equals("")){
					String zeile = s.substring(0, s.indexOf(System.getProperty("line.separator")));				
					if(zeile.indexOf("[[") != -1){
						start = start + setzeStart(zeile);
						setzeSkript(zeile, abschnitte[nr]);
						bausteine = bausteine + setzeBaustein(zeile);
						s = s.substring(s.indexOf(System.getProperty("line.separator"))+2, s.length());
					}else if(zeile.indexOf("[") != -1){
						links = links + zeile + System.getProperty("line.separator");
						s = s.substring(s.indexOf(System.getProperty("line.separator"))+2, s.length());
					}else{
						e = true;
					}
				}else
					e = true;
			}
			sb.delete(0, sb.indexOf("#")+2);
			abschnitte[nr].start = start;
			abschnitte[nr].text = text;
			abschnitte[nr].bausteine = bausteine;
			abschnitte[nr].da = true;

			for(int x = 0; links.length() != 0;){
				String href = "";
				x = links.indexOf(System.getProperty("line.separator"));
				if(x != -1){
					if(links.indexOf("[") != -1){
						href = links.substring(links.indexOf("[")+1, links.indexOf("]"));
						int folge = wandleZahl(href);
						if(folge != -1)
							abschnitte[nr].setzeNachfolger(abschnitte[folge], links.substring(0, x), false);
						else
							abschnitte[nr].setzeNachfolger(href, links.substring(0, x), false);
					}
					links = links.substring(x+2);
				}
			}
		}
		return true;
	}
	
	boolean schreibeAbschnitte(int von, int bis){
		for(int nr = von; nr <= bis; nr++){
			if(abschnitte[nr].da){
				String datei = fuelleDreistellig(nr);
				io.setzeDatei("C:\\Daten\\Allgemein\\DSA\\Ssad'Chaz\\Daten\\"+datei+".html");
				io.schreibeZeile("<html>");
				io.schreibeZeile("<head>");
				io.schreibeZeile("<meta http-equiv=\"content-type\" content=\"text/html; charset=UTF-8\">");
				io.schreibeZeile("<title>"+nr+"</title>");
				io.schreibeZeile("<link rel=\"stylesheet\" type=\"text/css\" href=\"styles.css\">");
				io.schreibeZeile("");
				io.schreibeZeile("<script type=\"text/javascript\">");
				io.schreibeZeile("");
				io.schreibeZeile("function start(){");
		        io.schreibeZeile("   top.Abschnitte.push("+nr+");");
				io.schreibeZeile(abschnitte[nr].start+"}");
				for(Skript sk = abschnitte[nr].skripte; sk != null; sk = sk.f){
					io.schreibeZeile(sk.gibSkript());
				}
				io.schreibeZeile("</script>");
				io.schreibeZeile("");
				io.schreibeZeile("</head>");
				io.schreibeZeile("<body onLoad=\"start()\">");
				io.schreibeZeile("");
				io.schreibeZeile("<table align=\"center\"><tr><td class=\"ue"+(nr < 10?"x":nr < 100?"xx":"xxx")+(nr%2+1)+"\">");
				io.schreibeZeile(nr+"");
				io.schreibeZeile("</td></tr></table>");
				io.schreibeZeile("<p>");
				String t = abschnitte[nr].text;
				for(int x = 0; t.length() > 90;){
					int y = 90;
					x = t.lastIndexOf("<br>", 90);
					if(x != -1){
						y = y + x;
					}
					x = t.lastIndexOf(" ", y);
					io.schreibeZeile(t.substring(0, x));
					t = t.substring(x+1);
				}
				io.schreibeZeile(t);
				io.schreibeZeile("</p>");
				io.schreibeZeile("");
				io.schreibeZeile(abschnitte[nr].bausteine);
				
				if(abschnitte[nr].nachfolger != null){
					for(int i = 0; i < abschnitte[nr].nachfolger.length;i++){
						if(!abschnitte[nr].bedingung[i]){
							String href = "";
							if(abschnitte[nr].nachfolger[i].nr != -1)
								href = fuelleDreistellig(abschnitte[nr].nachfolger[i].nr);
							else
								href = abschnitte[nr].nachfolger[i].bez;
							io.schreibeZeile("<a href=\""+href+".html\">"+abschnitte[nr].links[i]+"</a><br>");
						}
					}
				}
				io.schreibeZeile("");
				io.schreibeZeile("</body>");
				io.schreibeZeile("</html>");
				io.schliesseDatei();
			}
		}	
		return true;
	}
	
	void schreibeIndex(){
		GregorianCalendar gc = new GregorianCalendar();
		
		io.setzeDatei("C:\\Daten\\Allgemein\\DSA\\Ssad'Chaz\\index.html");
		io.schreibeZeile("<html>");
		io.schreibeZeile("<head>");
		io.schreibeZeile("<meta name=\"description\"  content=\"Ssad'Chaz\">");
		io.schreibeZeile("<meta name=\"keywords\"     content=\"DSA, Rollenspiel, Das Schwarze Auge, Abenteuer, Soloabenteuer\">");
		io.schreibeZeile("<meta name=\"author\"       content=\"tzzz pfff\">");
		io.schreibeZeile("<meta name=\"DC.Date\"      content=\"" + gc.get(Calendar.DATE) + "." + (gc.get(Calendar.MONTH)+1) + "." + gc.get(Calendar.YEAR) + "\">");
		io.schreibeZeile("<meta name=\"DC.Language\"  content=\"de\">");
		io.schreibeZeile("<meta http-equiv=\"content-type\" content=\"text/html; charset=UTF-8\">");
		io.schreibeZeile();
		io.schreibeZeile("<title>Ssad'Chaz</title>");
		io.schreibeZeile("<link rel=\"stylesheet\" type=\"text/css\" href=\"Daten/styles.css\">");
		io.schreibeZeile();
		io.schreibeZeile("<script type=\"text/javascript\">");
		io.schreibeZeile("var werte = -1;");
		io.schreibeZeile("var AP = new Array();");
		io.schreibeZeile("var SE = new Array();");
		io.schreibeZeile("var Abschnitte = new Array();");		
		io.schreibeZeile("var gesamtpunkte = 0;");
		io.schreibeZeile("var punkte = 0;");
		io.schreibeZeile();
		
		for(int i = 0; i < werte[0].length; i++){
			io.schreibeZeile("var " + werte[0][i] + " = 0;");
		}
		io.schreibeZeile();
		
		for(int i = 0; i < folgewerte.length; i++){
			io.schreibeZeile("var " + wandleString(folgewerte[i]) + " = 0;");
		}
		io.schreibeZeile();
		
		for(int i = 0; i < talente[0].length; i++){
			io.schreibeZeile("var " + wandleString(talente[0][i]) + " = 0;");
		}
		io.schreibeZeile();
		
		for(int i = 0; i < variablen.length; i++){
			io.schreibeZeile("var " + wandleString(variablen[i]) + " = 0;");
		}
		io.schreibeZeile();
		
		String felder = "var felder = new Array(";
		felder = felder + "\""+werte[0][0]+"\"";
		for(int i = 1; i < werte[0].length; i++){
			if(i%6 == 0)
				felder = felder + ", "+ System.getProperty("line.separator") + "\t\""+werte[0][i]+"\"";
			else
				felder = felder + ", \""+werte[0][i]+"\"";
		}
		for(int i = 0; i < talente[0].length; i++){
			if(i%6 == 0)
				felder = felder + ", "+ System.getProperty("line.separator") + "\t\""+wandleString(talente[0][i])+"\"";
			else
				felder = felder + ", \""+wandleString(talente[0][i])+"\"";
		}	
		felder = felder + ");";
		io.schreibeZeile(felder);
		
		String bezeichnungen = "var bezeichnungen = new Array(";
		bezeichnungen = bezeichnungen + "\""+werte[1][0]+"\"";
		for(int i = 1; i < werte[1].length; i++){
			if(i%6 == 0)
				bezeichnungen = bezeichnungen + ", "+ System.getProperty("line.separator") + "\t\""+werte[1][i]+"\"";
			else
				bezeichnungen = bezeichnungen + ", \""+werte[1][i]+"\"";
		}
		for(int i = 0; i < talente[0].length; i++){
			if(i%6 == 0)
				bezeichnungen = bezeichnungen + ", "+ System.getProperty("line.separator") + "\t\""+talente[0][i]+"\"";
			else
				bezeichnungen = bezeichnungen + ", \""+talente[0][i]+"\"";
		}
		bezeichnungen = bezeichnungen + ");";
		io.schreibeZeile(bezeichnungen);
		
		io.schreibeZeile();
		io.schreibeZeile("function gibBezeichnung(feld){");
		io.schreibeZeile("  for(var i = 0; i < felder.length; i++){");
		io.schreibeZeile("     if(felder[i] == feld){");
		io.schreibeZeile("        return bezeichnungen[i];");
		io.schreibeZeile("     }");
		io.schreibeZeile("  }");
		io.schreibeZeile("}");
		io.schreibeZeile();
		io.schreibeZeile("</script>");
		io.schreibeZeile();
		io.schreibeZeile("<frameset frameborder = 0>");
		io.schreibeZeile("  <frame src = \"Daten/home.html\" name = \"home\">");
		io.schreibeZeile("</frameset>");
		io.schreibeZeile();
		io.schreibeZeile("</head>");
		io.schreibeZeile("<body>");
		io.schreibeZeile();
		io.schreibeZeile("</body>");
		io.schreibeZeile("</html>");
		io.schliesseDatei();
	}
	
	void schreibeHeld(){
		io.setzeDatei("C:\\Daten\\Allgemein\\DSA\\Ssad'Chaz\\Daten\\Held.html");
		io.schreibeZeile("<html>");
		io.schreibeZeile("<head>");
		io.schreibeZeile("<meta http-equiv=\"content-type\" content=\"text/html; charset=UTF-8\">");
		io.schreibeZeile();
		io.schreibeZeile("<title>Held</title>");
		io.schreibeZeile("<link rel=\"stylesheet\" type=\"text/css\" href=\"styles.css\">");
		io.schreibeZeile();
		io.schreibeZeile("<script type=\"text/javascript\">");
		io.schreibeZeile();
		io.schreibeZeile("function sub(){");
		io.schreibeZeile("	if(checkFormular()){");
		io.schreibeZeile("		setzeWerte();");
		io.schreibeZeile("	}else{");
		io.schreibeZeile("		return false;");
		io.schreibeZeile("	}");
		io.schreibeZeile("}");
		io.schreibeZeile();
		io.schreibeZeile("function checkFormular() {");
		io.schreibeZeile("	felder = top.felder;");
		io.schreibeZeile("	bezeichnungen = top.bezeichnungen;");
		io.schreibeZeile("	for(i = 0; i < felder.length; i++){");
		io.schreibeZeile("		knoten = document.getElementsByName(felder[i])[0];");
		io.schreibeZeile("		if (knoten.value == \"\") {");
		io.schreibeZeile("			alert(\"Das Feld '\"+bezeichnungen[i]+\"' ist leer!\");");
		io.schreibeZeile("			knoten.focus();");
		io.schreibeZeile("			return false;");
		io.schreibeZeile("		}");
		io.schreibeZeile("	}");
		io.schreibeZeile();
		io.schreibeZeile("	for(i = 2; i < felder.length; i++){");
		io.schreibeZeile("		var pruefeZahl = 1;");
		io.schreibeZeile("		knoten = document.getElementsByName(felder[i])[0];");
		io.schreibeZeile("		for(j = 0; j < knoten.value.length; j++){");
		io.schreibeZeile("			if (!(knoten.value.charAt(j) >= \"0\" && knoten.value.charAt(j) <= \"9\" || knoten.value.charAt(j) == \"-\"))");
		io.schreibeZeile("				pruefeZahl = -1;");
		io.schreibeZeile("			if (knoten.value.indexOf(\"-\") > 0)");
		io.schreibeZeile("				pruefeZahl = -1;");
		io.schreibeZeile("		}");
		io.schreibeZeile("		if(pruefeZahl == -1){");
		io.schreibeZeile("			alert(\"Der Wert \"+bezeichnungen[i]+\" muss eine Zahl sein!\");");
		io.schreibeZeile("			knoten.focus();");
		io.schreibeZeile("			return false;");
		io.schreibeZeile("		}");
		io.schreibeZeile("	}");
		io.schreibeZeile("	return true;");
		io.schreibeZeile("}");
		io.schreibeZeile();
		io.schreibeZeile("function setzeWerte(){");
		io.schreibeZeile("	top.werte = 1;");
		
		for(int i = 0; i < werte[0].length; i++){
			if(werte[0][i].equals("vorname") || werte[0][i].equals("nachname")){
				io.schreibeZeile("	top."+werte[0][i]+" = document.F."+werte[0][i]+".value;");
			}else{
				io.schreibeZeile("	top."+werte[0][i]+" = parseInt(document.F."+werte[0][i]+".value);");
			}
		}
		io.schreibeZeile();
		for(int i = 0; i < talente[0].length; i++){
			if(talente[1][i].equals("int"))
				io.schreibeZeile("	top."+wandleString(talente[0][i])+" = parseInt(document.F."+wandleString(talente[0][i])+".value);");
			else
				io.schreibeZeile("	if(document.F."+wandleString(talente[0][i])+".checked){ top."+wandleString(talente[0][i])+" = 1; }else{ top."+wandleString(talente[0][i])+" = 0; }");
		}
		
		io.schreibeZeile();
		io.schreibeZeile("	top.Stufe = (5 + Math.sqrt(25+2*top.gAP)) / 10;");
		io.schreibeZeile("	top.maxLE = top.LE;");
		io.schreibeZeile("	top.maxAU = top.AU;");
		io.schreibeZeile("	top.BasiswertPA = Math.round((top.IN + top.GE + top.KK) / 5);");
		io.schreibeZeile("	top.Ausweichen = top.BasiswertPA;");
		
		io.schreibeZeile();
		io.schreibeZeile("	return true;");
		io.schreibeZeile("}");
		io.schreibeZeile();
		io.schreibeZeile("</script>");
		io.schreibeZeile("</head>");
		io.schreibeZeile("<body>");
		io.schreibeZeile();
		io.schreibeZeile("<h2>Dein Held</h2>");
		io.schreibeZeile();
		io.schreibeZeile("<form name=\"F\" action=\"home2.html\" target=\"home\" method=\"get\" onsubmit=\"return sub()\">");
		io.schreibeZeile();
		int j = 0;
		io.schreibeZeile("<table border=\"0\" width=100% cellpadding=\"0\" cellspacing=\"4\">");
		io.schreibeZeile("	<tr>");
		io.schreibeZeile("		<td align=\"right\">Vorname:</td>");
		io.schreibeZeile("		<td><input name=\"vorname\" value=\"\" type=\"text\" tabindex=\"1\" size=\"30\" maxlength=\"60\"></td>");
		j++;
		io.schreibeZeile("		<td>&nbsp;</td>");
		io.schreibeZeile("		<td align=\"right\">Abenteuerpunkte:</td>");
		io.schreibeZeile("		<td><input name=\"gAP\" value=\"0\" type=\"text\" size=\"4\" maxlength=\"4\"></td>");
		j++;
		io.schreibeZeile("	</tr>");
		io.schreibeZeile("	<tr>");
		io.schreibeZeile("		<td align=\"right\">Nachname:</td>");
		io.schreibeZeile("		<td><input name=\"nachname\" value=\"\" type=\"text\" tabindex=\"2\" size=\"30\" maxlength=\"60\"></td>");
		j++;
		io.schreibeZeile("		<td>&nbsp;</td>");
		io.schreibeZeile("		<td align=\"right\">Geld:</td>");
		io.schreibeZeile("		<td><input name=\"D\" value=\"0\" type=\"text\" tabindex=\"3\" size=\"2\" maxlength=\"3\"> Dukaten,</td>");
		j++;
		io.schreibeZeile("		<td><input name=\"S\" value=\"0\" type=\"text\" tabindex=\"4\" size=\"2\" maxlength=\"3\"> Silbertaler,</td>");
		j++;
		io.schreibeZeile("		<td><input name=\"H\" value=\"1\" type=\"text\" tabindex=\"5\" size=\"2\" maxlength=\"3\"> Heller</td>");
		j++;
		io.schreibeZeile("	</tr>");
		io.schreibeZeile("</table>");
		io.schreibeZeile("<hr>");
		io.schreibeZeile("<br>");
		
		io.schreibeZeile("<table border=\"0\" width=100% cellpadding=\"0\" cellspacing=\"4\">");
		
		String trefferpunkte = "		<td align=\"right\">Trefferpunkte:</td>" + System.getProperty("line.separator") +
							   "		<td><input name=\"wuerfelTP\" value=\"1\" type=\"text\" size=\"1\" maxlength=\"1\">W6 +" + System.getProperty("line.separator") +
							   "		    <input name=\"zusatzTP\" value=\"1\" type=\"text\" size=\"1\" maxlength=\"1\"></td>";
		
		int viertelj = ((werte[0].length - 1 - (j-1)) / 4);

		int k = viertelj + j;
		int l = viertelj*2 + j;
		int m = viertelj*3 + j;
		int grenzj = k;
		int grenzk = l;
		int grenzl = m;
		int grenzm = werte[0].length;
		for(; m < grenzm; j++, k++, l++, m++){
			io.schreibeZeile("	<tr>");
			if(j >= grenzj){
				io.schreibeZeile("		<td>&nbsp;</td>");
				io.schreibeZeile("		<td>&nbsp;</td>");				
			}else if(werte[0][j].equals("wuerfelTP")){
				io.schreibeZeile(trefferpunkte);
				j++;
			}else{
				io.schreibeZeile("		<td align=\"right\">"+werte[1][j]+":</td>");
				io.schreibeZeile("		<td><input name=\""+werte[0][j]+"\" value=\"0\" type=\"text\" size=\"2\" maxlength=\"2\"></td>");
			}
			
			io.schreibeZeile("		<td>&nbsp;</td>");
			
			if(k >= grenzk){
				io.schreibeZeile("		<td>&nbsp;</td>");
				io.schreibeZeile("		<td>&nbsp;</td>");				
			}else if(werte[0][k].equals("wuerfelTP")){
				io.schreibeZeile(trefferpunkte);
				k++;
			}else{
				io.schreibeZeile("		<td align=\"right\">"+werte[1][k]+":</td>");
				io.schreibeZeile("		<td><input name=\""+werte[0][k]+"\" value=\"0\" type=\"text\" size=\"2\" maxlength=\"2\"></td>");
			}
			
			io.schreibeZeile("		<td>&nbsp;</td>");

			if(l >= grenzl){
				io.schreibeZeile("		<td>&nbsp;</td>");
				io.schreibeZeile("		<td>&nbsp;</td>");				
			}else if(werte[0][l].equals("wuerfelTP")){
				io.schreibeZeile(trefferpunkte);
				l++;
			}else{
				io.schreibeZeile("		<td align=\"right\">"+werte[1][l]+":</td>");
				io.schreibeZeile("		<td><input name=\""+werte[0][l]+"\" value=\"0\" type=\"text\" size=\"2\" maxlength=\"2\"></td>");
			}
			
			io.schreibeZeile("		<td>&nbsp;</td>");
			
			if(m >= grenzm){
				io.schreibeZeile("		<td>&nbsp;</td>");
				io.schreibeZeile("		<td>&nbsp;</td>");				
			}else if(werte[0][m].equals("wuerfelTP")){
				io.schreibeZeile(trefferpunkte);
				m++;
			}else{
				io.schreibeZeile("		<td align=\"right\">"+werte[1][m]+":</td>");
				io.schreibeZeile("		<td><input name=\""+werte[0][m]+"\" value=\"0\" type=\"text\" size=\"2\" maxlength=\"2\"></td>");
			}			
			io.schreibeZeile("	</tr>");

		}
		io.schreibeZeile("</table>");
		io.schreibeZeile("<hr>");
		io.schreibeZeile("<br>");
		
		io.schreibeZeile("<table border=\"0\" width=100% cellpadding=\"0\" cellspacing=\"4\">");
				
		int dritteln = talente[0].length / 3;
		int restn = talente[0].length % 3;
		int zusatz = 0;
		
		int n = 0;
		if(restn!=0){zusatz++; restn--;}
		int o = dritteln + zusatz;
		if(restn!=0){zusatz++; restn--;}
		int p = dritteln*2 + zusatz;

		int grenzn = o;
		int grenzo = p;
		int grenzp = talente[0].length;
		
		for(; p < grenzp +  (zusatz==0?0:1); n++, o++, p++){
			io.schreibeZeile("	<tr>");
			if(n >= grenzn){
				io.schreibeZeile("		<td>&nbsp;</td>");
				io.schreibeZeile("		<td>&nbsp;</td>");	
			}else{
				io.schreibeZeile("		<td align=\"right\">"+talente[0][n]+":</td>");
				io.schreibeZeile("		<td><input name=\""+wandleString(talente[0][n])+"\" value=\"0\" type=\""+(talente[1][n].equals("int")?"text":"checkbox")+"\" size=\"2\" maxlength=\"2\"></td>");			
			}			
			io.schreibeZeile("		<td>&nbsp;</td>");
			
			if(o >= grenzo){
				io.schreibeZeile("		<td>&nbsp;</td>");
				io.schreibeZeile("		<td>&nbsp;</td>");	
			}else{
				io.schreibeZeile("		<td align=\"right\">"+talente[0][o]+":</td>");
				io.schreibeZeile("		<td><input name=\""+wandleString(talente[0][o])+"\" value=\"0\" type=\""+(talente[1][o].equals("int")?"text":"checkbox")+"\" size=\"2\" maxlength=\"2\"></td>");
			}
			io.schreibeZeile("		<td>&nbsp;</td>");
			
			if(p >= grenzp){
				io.schreibeZeile("		<td>&nbsp;</td>");
				io.schreibeZeile("		<td>&nbsp;</td>");					
			}else{			
				io.schreibeZeile("		<td align=\"right\">"+talente[0][p]+":</td>");
				io.schreibeZeile("		<td><input name=\""+wandleString(talente[0][p])+"\" value=\"0\" type=\""+(talente[1][p].equals("int")?"text":"checkbox")+"\" size=\"2\" maxlength=\"2\"></td>");
			}
			io.schreibeZeile("	</tr>");
		}
		io.schreibeZeile("</table>");
	   
		io.schreibeZeile("<table>");
		io.schreibeZeile("	<tr>");
		io.schreibeZeile("		<td>");
		io.schreibeZeile("			<input type=\"submit\" value=\" Absenden \">");
		io.schreibeZeile("			<input type=\"reset\" value=\" Zurcksetzen \">");
		io.schreibeZeile("		</td>");
		io.schreibeZeile("	</tr>");
		io.schreibeZeile("</table>");
		io.schreibeZeile("</form>");
		io.schreibeZeile();
		io.schreibeZeile("Anmerkung: Bei nichtvorhandenen Talenten bitte -99 eintragen.");
		io.schreibeZeile("</body>");
		io.schreibeZeile("</html>");
		io.schliesseDatei();
	}
}
